#include  "gtk_interface_controller.h"
#include  "interactive_window.h"

Gtk_Interface_Controller::Gtk_Interface_Controller
		( const ref_count_ptr<Gtk_Interface_Abstraction> &  a )
	: abstraction( a )  ,
	  presentation( static_cast<Interactive_Window *>(0) ) ,
	  move_clear_flag( false ) , kick_clear_flag( false )
{
}

Gtk_Interface_Controller::~Gtk_Interface_Controller()
{
}

void   Gtk_Interface_Controller::set_presentation
			( const ref_count_ptr<Interactive_Window> &  p )
{
	this -> presentation = p;
}

void   Gtk_Interface_Controller::step_start()
{
	presentation -> display();
}

void   Gtk_Interface_Controller::step_end()
{
	if ( this -> move_clear_flag )
	{
		abstraction -> move_flag = false;
		this -> move_clear_flag = false;
	}

	if ( this -> kick_clear_flag )
	{
		abstraction -> kick_flag = false;
		this -> kick_clear_flag = false;
	}
}


ref_count_ptr<const Gtk_Interface_Abstraction>
			Gtk_Interface_Controller::get_abstraction() const
{
	return( this -> abstraction );
}

const Field_Recog_Interface &  Gtk_Interface_Controller::f() const
{
	return( abstraction -> f );
}

const Game_Info_Mode_Line::Model &  Gtk_Interface_Controller::mode_line_model()
	const
{
	return( abstraction -> mode_line_model );
}

const Stamina_Gauge::Model &  Gtk_Interface_Controller::stamina_model()
	const
{
	return( abstraction -> stamina_model );
}


void   Gtk_Interface_Controller::set_kick_target( const D2_Vector &  p )
{
	this -> kick_clear_flag = false;

	abstraction -> kick_flag = true;
	abstraction -> kick_target_point = p;
}

void   Gtk_Interface_Controller::set_kick_type( bool  hard_kick )
{
	abstraction -> hard_kick_flag = hard_kick;
}

void   Gtk_Interface_Controller::clear_kick_target()
{
	this -> kick_clear_flag = true;
}


void   Gtk_Interface_Controller::set_get_ball( bool  flag )
{
	abstraction -> get_ball_flag = flag;
}


void   Gtk_Interface_Controller::set_move_target( const D2_Vector &  p )
{
	this -> move_clear_flag = false;

	abstraction -> move_flag = true;
	abstraction -> move_target_point = p;
}

void   Gtk_Interface_Controller::clear_move_target()
{
	this -> move_clear_flag = true;
}

void   Gtk_Interface_Controller::set_force_neck( const D2_Vector &  p )
{
	abstraction -> neck_flag = true;
	abstraction -> neck_target_point = p;
}

void   Gtk_Interface_Controller::clear_force_neck()
{
	abstraction -> neck_flag = false;
}
