#ifndef	   FILE_EVOLUTIONAL_REPOSITORY_H_INCLUDED
#define	   FILE_EVOLUTIONAL_REPOSITORY_H_INCLUDED

// Author:		H. Shimora
// Created:		Oct  6 2002
// Version:		0.00

//------------------------------------------------
// Change Log:
//------------------------------------------------
// version 0.00  Oct  6 2002    base version.
//
//

#include  "evolutional_repository.h"
#include  <map>
#include  <string>
#include  <fstream>
#include  <cctype>

class  File_Evolutional_Repository : public Evolutional_Repository
{
private:
	typedef std::map<std::string, std::string>	Map_Type;

private:
	Map_Type	values;

public:
	File_Evolutional_Repository( const std::string &  path )
		: values()
	{
		std::ifstream	file( path.c_str() );

		if ( ! file )
		{
			std::cerr << "can't open file: " << path << std::endl;
			return;
		}

		for(;;)
		{
			std::string	line;
			std::getline( file , line );

			if ( file.eof() || ! file )
			{
				break;
			}

			// XXX: should be more smart.
			std::string	key;
			bool		colon_found = false;
			size_t	i = 0;

			for ( i = 0  ;  i < line.length()  ;  i ++ )
			{
				if ( line[i] == ':' )
				{
					colon_found = true;
					i ++;
					break;
				}

				key += line[i];
			}

			for (  ;  i < line.length()  ;  i ++ )
			{
				if ( line[i] != ' '
				  && line[i] != '\t' )
				{
					break;
				}
			}

			std::string	value( line , i );

			if ( ! colon_found )
			{
				std::cerr << "parse error: [" << line << "]"
					  << std::endl;
			}
			else
			{
				this -> values.insert( Map_Type::value_type
						       ( key , value ) );
			}
		}
	}

	virtual	~File_Evolutional_Repository()
	{
	}

	virtual	void	get_value( const std::string &  name ,
				   std::string *  value ,
				   std::string *  id )
	{
		Map_Type::const_iterator
			it = this -> values.find( name );

		if ( it == this -> values.end() )
		{
			std::cerr << name << ": not found in file."
				  << std::endl;

			*value = "";
		}
		else
		{
			*value = (*it).second;
		}

		*id = "";
	}

	virtual	void	evaluate( const std::string & ,
				  const std::string & ,
				  double )
	{
		// no operation is needed for evaluate()
	}

	virtual	void	evaluation_cancel( const std::string & ,
					   const std::string & )
	{
		// no operation is needed for evaluation_cancel()
	}
};


#endif	/* FILE_EVOLUTIONAL_REPOSITORY_H_INCLUDED */
