#include  "ip_address.h"
#include  <iostream>
#include  <cstdio>

extern "C"
{
	#include  <sys/types.h>
	#include  <sys/socket.h>
	#include  <netinet/in.h>
	#include  <netdb.h>
}


IPv4_Address::IPv4_Address( const std::string &  host )
	: address( 0x00000000 )
{
	struct hostent *	hp;
	if ( (hp = gethostbyname( host.c_str() ))  ==  NULL )
	{
		std::perror( "gethostbyname" );
	}

	std::memcpy( &address , hp -> h_addr , hp -> h_length );

	// <<TRANSLATE TO HOST BYTE ORDER>>
	// translate network byte order
	//   to machne depend(NOT NETWORK) byte order
	address = htonl( address );
}


std::ostream &  operator<< ( std::ostream &  ostrm ,
			     const IPv4_Address &  addr )
{
	ostrm << ((addr >> (8*3)) & 0xff) << "."
	      << ((addr >> (8*2)) & 0xff) << "."
	      << ((addr >> (8*1)) & 0xff) << "."
	      << ((addr >> (8*0)) & 0xff);

	return( ostrm );
}
