#ifndef	   STREAM_SOCKET_WRAPPER_H_INCLUDED
#define	   STREAM_SOCKET_WRAPPER_H_INCLUDED

// Author:		H. Shimora
// Created:		Jun  8 2002
// Version:		0.00

//------------------------------------------------
// Change Log:
//------------------------------------------------
// version 0.00  Jun  8 2002    base version.
//

#include  "stream_socket.h"
#include  "ref_count_ptr.h"
#include  <string>

class  Stream_Socket_Wrapper
{
private:
	mutable	ref_count_ptr<Stream_Socket>	sock;

	mutable	bool				have_newline;
	mutable	std::string			line;

private:
	bool	internal_read_char( bool  block );

public:
		 Stream_Socket_Wrapper
				( const ref_count_ptr<Stream_Socket> &  sock
					  = static_cast<Stream_Socket *>(0) );

	virtual	~Stream_Socket_Wrapper();

	virtual	void	handle( const ref_count_ptr<Stream_Socket> &  sock );

	virtual	operator bool () const;
	virtual	bool	valid() const;

	virtual	ref_count_ptr<Stream_Socket>	socket() const;
	virtual	int				fd() const;
	virtual	bool				poll() const;
	virtual	void				close();
	virtual	int				set_close_on_exec();
	virtual	bool				connected() const;

	virtual	bool				line_completed() const;
	virtual	std::string			get_line();

	virtual void				recv_message
						  ( std::string *  mes );

	virtual void				send_message
						  ( const std::string &  mes )
									const;
};


#endif	/* STREAM_SOCKET_WRAPPER_H_INCLUDED */
