#ifndef	   STRING_EXTENSION_H_INCLUDED
#define	   STRING_EXTENSION_H_INCLUDED

// Author:		H. Shimora
// Created:		Oct 26 2002
// Version:		0.00

//------------------------------------------------
// Change Log:
//------------------------------------------------
// version 0.00  Oct 26 2002    base version.
//
//

#include  <string>
#include  <vector>

namespace  String_Extension
{

	extern	void		split_by_char_set
				    ( std::vector<std::string> *  result ,
				      const std::string &  str ,
				      const std::string &  char_set ,
				      bool  do_cutoff_edge = false );


	extern	bool		string_to_integer( int *     result ,
						   const std::string &  str );
	extern	bool		string_to_long   ( long *    result ,
						   const std::string &  str );
	extern	bool		string_to_double ( double *  result ,
						   const std::string &  str );


	extern	void		double_to_string( std::string *  result ,
						  double  value );


	extern	std::string	chomp( const std::string &  str );
	extern	void		chomp( std::string *  str );


	extern	std::string	cutoff_edge( const std::string &  str ,
					     const std::string &  char_set );
	extern	void		cutoff_edge( std::string *  str ,
					     const std::string &  char_set );


	extern	std::string	cutoff_edge_spaces( const std::string &  str );
	extern	void		cutoff_edge_spaces( std::string *  str );


} // end of namespace String_Extension


#endif	/* STRING_EXTENSION_H_INCLUDED */
