#ifdef SAY_MESSAGE_TRANSLATOR_TEST
#include  "say_message_translator.h"
#include  <iostream>

int    main( void )
{
	unsigned int	data = 36;

	unsigned char	ch = Say_Message_Translator::instance()
							.marshal_char( data );

	std::cout << data << " -> '" << ch << "'" << std::endl;

	unsigned int	decoded_data = Say_Message_Translator::instance()
							.unmarshal_char( ch );

	std::cout << "'" << ch << "' -> " << decoded_data << std::endl;

	return( 0 );
}

#endif // SAY_MESSAGE_TRANSLATOR_TEST


#include  "say_message_translator.h"
#include  <cstring>
#include  <cassert>

const	char *	Say_Message_Translator::SAY_MESSAGE_CHARS
						= "0123456789"
						  "abcdefghijklmnopqrstuvwxyz"
						  "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
						  " ().+-*/?<>_";

const	size_t	Say_Message_Translator::N_SAY_MESSAGE_CHARS
					= std::strlen( SAY_MESSAGE_CHARS );

ref_count_ptr<Say_Message_Translator>  Say_Message_Translator::instance_;


Say_Message_Translator::Say_Message_Translator()
	: unmarshaling_table()
{
	for ( size_t  i = 0  ;  i < N_SAY_MESSAGE_CHARS  ;  i ++ )
	{
		this -> unmarshaling_table[SAY_MESSAGE_CHARS[i]] = i;
	}
}

Say_Message_Translator::~Say_Message_Translator()
{
}

const Say_Message_Translator &  Say_Message_Translator::instance()
{
	if ( ! instance_ )
	{
		instance_ = new Say_Message_Translator;
	}

	return( *instance_ );
}

unsigned char  Say_Message_Translator::marshal_char( unsigned int  data ) const
{
	assert( data < N_SAY_MESSAGE_CHARS );

	if ( data >= N_SAY_MESSAGE_CHARS )
	{
		return( '\0' );
	}
	else
	{
		return( SAY_MESSAGE_CHARS[data] );
	}
}

unsigned int  Say_Message_Translator::unmarshal_char( unsigned char  ch ) const
{
	std::map<unsigned char, unsigned char>::const_iterator
		it = this -> unmarshaling_table.find( ch );

	assert( it != this -> unmarshaling_table.end() );

	if ( it == this -> unmarshaling_table.end() )
	{
		return( 0 );
	}
	else
	{
		return( (*it).second );
	}
}
