#ifndef	   SAY_MESSAGE_TRANSLATOR_H_INCLUDED
#define	   SAY_MESSAGE_TRANSLATOR_H_INCLUDED

// Author:		H. Shimora
// Created:		Mar 19 2002
// Version:		0.00

//------------------------------------------------
// Change Log:
//------------------------------------------------
// version 0.00  Mar 19 2002    base version.
//
//

#include  <map>
#include  <ref_count_ptr.h>

class  Say_Message_Translator
{
public:
	static	const	char *		SAY_MESSAGE_CHARS;
	static	const	size_t		N_SAY_MESSAGE_CHARS;

private:
	// don't allow instantiation
	Say_Message_Translator(); // don't allow instantiation
	Say_Message_Translator( const Say_Message_Translator & );
	Say_Message_Translator &	operator =
					( const Say_Message_Translator & );

private:
	std::map<unsigned char, unsigned char>	unmarshaling_table;

public:
	static	ref_count_ptr<Say_Message_Translator>	instance_;
	static	const Say_Message_Translator &		instance();

	~Say_Message_Translator();

public:
	unsigned char	marshal_char( unsigned int  data ) const;
	unsigned int	unmarshal_char( unsigned char  ch ) const;
};


#endif	/* SAY_MESSAGE_TRANSLATOR_H_INCLUDED */
