#ifndef	   SOCCER_ACTION_H_INCLUDED
#define	   SOCCER_ACTION_H_INCLUDED

#include  "soccer_composite_command.h"
#include  "ref_count_ptr.h"

class  Field_Recog_Interface;

class  Soccer_Action
{
private:
	bool	fin;
	bool	suc;

	mutable	bool	act_initialized;

protected:
	const Field_Recog_Interface &	f;

		void	set_finished() /* throw() */;
		void	set_unfinished() /* throw() */;

		void	set_succeeded() /* throw() */;
		void	set_failed() /* throw() */;

protected:
	virtual	void	initialize() const;

public:
		 Soccer_Action( const Field_Recog_Interface & ) /* throw() */;
	virtual	~Soccer_Action();

	virtual	Soccer_Composite_Command	action() = 0;
	virtual	ref_count_ptr<Soccer_Action>	clone() const = 0;

	virtual	Soccer_Composite_Command	get_command();
	virtual	bool				finished() const;
	virtual	bool				succeeded() const;

	virtual	bool				evaluate();
};


#endif	/* SOCCER_ACTION_H_INCLUDED */
