#include  "log_supplyer.h"
#include  "comstream.h"
#include  <fcntl.h>
#include  <iostream>
#include  <cstdlib>

Log_Supplyer::Log_Supplyer
		( const ref_count_ptr<Abstruct_Updator> &  updator ,
		  const ref_count_ptr<Abstruct_Updator::Callback> &  callback ,
		  const std::string &  file_name )
	: file( updator , callback , file_name ) ,
	  version( -1 ) , v3_play_mode()
{
	if ( ! file.valid() )
	{
		std::cerr << "Can't open file \"" << file_name << "\"."
			  << std::endl;

		std::exit( 1 );
	}


	v3_play_mode = SServer_Monitor_Log_Format::Null_Mode;
	v3_team[0].name[0] = '\0';
	v3_team[1].name[0] = '\0';
	v3_team[0].score = 0;
	v3_team[1].score = 0;

	char	ulg[4];

	if ( ! this -> file.input_stream().read( ulg , 4 )
	     || file.input_stream().gcount() != 4
	     || ulg[0] != 'U'
	     || ulg[1] != 'L'
	     || ulg[2] != 'G'
	     || (   ulg[3] != SServer_Monitor_Log_Format::REC_VERSION_2
		 && ulg[3] != SServer_Monitor_Log_Format::REC_VERSION_3 ) )
	{
		std::cerr << "Can't interpret \"" << file_name << "\"."
			  << std::endl;

		std::exit( 1 );
	}

	switch( ulg[3] )
	{
	case  SServer_Monitor_Log_Format::REC_VERSION_2:
		version = 2;
		break;

	case  SServer_Monitor_Log_Format::REC_VERSION_3:
		version = 3;
		break;

	default:
		version = -1;
		break;
	}
}

Log_Supplyer::~Log_Supplyer()
{
}

ref_count_ptr<const Monitor_View_Data>
  Log_Supplyer::get( bool *  have_s_param ,
		     SServer_Monitor_Log_Format::server_param_t *  s_param )
{
	*have_s_param = false;


	//
	// get data
	//
	if ( this -> file.eof() )
	{
		return( static_cast<Monitor_View_Data *>(0) );
	}
	else
	{
		switch( version )
		{
		case  2:
			return( SServer_Monitor_Log_Format
				::parse_dispinfo_t
				  ( this -> file.input_stream() ) );
			break;

		case  3:
			return( SServer_Monitor_Log_Format
				::parse_log_v3
				  ( this -> file.input_stream() ,
				    &v3_play_mode , v3_team ,
				    have_s_param , s_param ) );
			break;

		default:
			return( static_cast<Monitor_View_Data *>(0) );
			break;
		}
	}
}

bool   Log_Supplyer::responsive() const
{
	return( ! this -> file.eof() );
}
