#include  "soccer_viewer.h"
#include  "active_repository.h"
#include  "gtk_updator.h"
#include  "soccer_viewer_option_analyzer.h"
#include  "ref_count_ptr.h"
#include  <exception>
#include  <iostream>

#include  <gtk--.h>


int    main( int  argc ,  char *  argv[] )
{
	Soccer_Viewer_Option_Analyzer	opt;

	if ( ! opt.analyze( argc , argv ) )
	{
		opt.usage();

		return( 1 );
	}
	else if ( opt.help() )
	{
		opt.usage();

		return( 0 );
	}


	try
	{
		Gtk::Main	gtk( &argc , &argv );

		Active_Repository	repository
					( new Gtk_Updator_Factory ,
					  opt.server_host() ,
					  opt.server_port() ,
					  opt.debug_port() ,
					  opt.server_protocol_version() ,
					  opt.log_file_source() ,
					  opt.log_file_name() ,
					  opt.receive_debug() ,
					  opt.interpret_client_log() ,
					  opt.client_log_directory() ,
					  opt.client_log_viewer_command() ,
					  opt.auto_drop() ,
					  opt.auto_kick_off() ,
					  opt.auto_quit() ,
					  opt.auto_kill_server() ,
					  opt.time_limit() ,
					  opt.server_process_id() );


		ref_count_ptr<Soccer_Viewer>	viewer;

		if ( ! opt.no_windows() )
		{
			viewer = new Soccer_Viewer
				      ( repository ,
					opt.default_window_size() ,
					opt.log_file_source() ,
					opt.have_left_team_config() ,
					opt.left_team_config_file_name() ,
					opt.have_right_team_config() ,
					opt.right_team_config_file_name() ,
					opt.draw_player_view_cone() ,
					opt.player_view_cone_radius() ,
					opt.draw_offside_line() ,
					opt.draw_stamina() ,
					opt.draw_grid() ,
					opt.grid_width() ,
					opt.reverse_x() ,
					opt.reverse_y() ,
					opt.field_grass_type() );
		}

		gtk.run();
	}
	catch( const std::exception &  e )
	{
		std::cerr << e.what() << std::endl;
	}
	catch(...)
	{
		std::cerr << "unknown exception" << std::endl;
	}

	return( 0 );
}
