#ifndef	   SOCCER_VIEWER_OPTION_ANALYZER_H_INCLUDED
#define	   SOCCER_VIEWER_OPTION_ANALYZER_H_INCLUDED

#include  "option_analyzer.h"
#include  "ip_address.h"
#include  "sserver_param.h"
#include  "field_canvas.h"
#include  <string>
#include  <iostream>
#include  <utility>

class  Soccer_Viewer_Option_Analyzer : public Option_Analyzer
{
private:
	bool		help_;

	std::string	server_host_;
	port_number_t	server_port_;
	port_number_t	debug_port_;

	int		server_protocol_version_;
	bool		log_file_source_;
	std::string	log_file_name_;

	bool		receive_debug_;
	bool		interpret_client_log_;

	bool		have_left_team_config_;
	std::string	left_team_config_file_name_;
	bool		have_right_team_config_;
	std::string	right_team_config_file_name_;

	std::string	client_log_directory_;
	std::string	client_log_viewer_command_;

	bool		draw_player_view_cone_;
	double		player_view_cone_radius_;
	bool		draw_offside_line_;
	bool		draw_stamina_;
	bool		draw_grid_;
	double		grid_width_;

	bool		auto_drop_;
	bool		auto_kick_off_;
	bool		auto_quit_;
	bool		auto_kill_server_;

	long		time_limit_;

	int		server_process_id_;

	bool		reverse_x_;
	bool		reverse_y_;

	Field_Canvas::Field_Grass_Type	field_grass_type_;

	bool				no_windows_;
	std::pair<int, int>		default_window_size_;


protected:
	virtual	void	after_analyze_hook();


public:
		 Soccer_Viewer_Option_Analyzer
		   ( const std::string &  default_server_host = "localhost" ,
		     port_number_t  default_server_port
					 = SServer_Param::DEFAULT_PORT ,
		     port_number_t  default_debug_port
					 = 0 /* = server_port
						  + Debug_Server_Connection
						    ::DEFAULT_PORT_OFFSET */ );
	virtual	~Soccer_Viewer_Option_Analyzer();

	virtual	void	usage( std::ostream *  ostr = &std::cerr ) const;


	virtual	bool			help() const;

	virtual	std::string		server_host() const;
	virtual	port_number_t		server_port() const;
	virtual	port_number_t		debug_port() const;

	virtual	int			server_protocol_version() const;
	virtual	bool			log_file_source() const;
	virtual	std::string		log_file_name() const;

	virtual	bool			receive_debug() const;
	virtual	bool			interpret_client_log() const;

	virtual	bool			have_left_team_config() const;
	virtual	std::string		left_team_config_file_name() const;
	virtual	bool			have_right_team_config() const;
	virtual	std::string		right_team_config_file_name() const;

	virtual	std::string		client_log_viewer_command() const;
	virtual	std::string		client_log_directory() const;

	virtual	bool			draw_player_view_cone() const;
	virtual	double			player_view_cone_radius() const;
	virtual	bool			draw_offside_line() const;
	virtual	bool			draw_stamina() const;
	virtual	bool			draw_grid() const;
	virtual	double			grid_width() const;

	virtual	bool			auto_drop() const;
	virtual	bool			auto_kick_off() const;
	virtual	bool			auto_quit() const;
	virtual	bool			auto_kill_server() const;

	virtual	long			time_limit() const;

	virtual	pid_t			server_process_id() const;

	virtual	bool			reverse_x() const;
	virtual	bool			reverse_y() const;

	virtual	Field_Canvas::Field_Grass_Type
					field_grass_type() const;

	virtual	std::pair<int, int>	default_window_size() const;
	virtual	bool			no_windows() const;
};


#endif	/* SOCCER_VIEWER_OPTION_ANALYZER_H_INCLUDED */
