#ifndef	   VIEWER_FIELD_CANVAS_H_INCLUDED
#define	   VIEWER_FIELD_CANVAS_H_INCLUDED

// Author:		H. Shimora
// Created:		Mar 10 2001
// Version:		0.00

///-----------------------------------------------
/// Change Log:
///-----------------------------------------------
// version 0.00  Mar 10 2001    base version.
//
//

#include  "field_canvas.h"
#include  "view_config.h"

class  Viewer_Field_Canvas : public Field_Canvas
{
public:
	class  Monitor_Connection
	{
	public:
		virtual	~Monitor_Connection() {}
		virtual	int	send_foul( double  x ,  double  y ,
					   S_Side_LR  side ) = 0;
	};


protected:
	Viewer_Field_Canvas::Monitor_Connection &	monitor;

protected:
	Gtk::Window	drop_menu_window;
	Gtk::VBox	drop_menu_vbox;
	Gtk::Button	drop_ball_button;
	Gtk::Button	free_kick_left_button;
	Gtk::Button	free_kick_right_button;

	D2_Vector	drop_point;

	virtual	void	drop_ball();
	virtual	void	free_kick_left();
	virtual	void	free_kick_right();

public:
		 Viewer_Field_Canvas
			 ( Field_Canvas::Canvas_Event_Handler &  handler ,
			   Viewer_Field_Canvas::Monitor_Connection &  monitor ,
			   View_Config &  config ,
			   const SServer_Param &  param ,
			   gdouble  view_point_x ,
			   gdouble  view_point_y ,
			   gdouble  mag ,
			   bool  inv_x ,
			   bool  inv_y ,
			   Field_Canvas::Field_Grass_Type  g_type );

	virtual	~Viewer_Field_Canvas();
	virtual	gint	button_press_event_impl( GdkEventButton * );
	virtual	gint	button_release_event_impl( GdkEventButton * );
};


#endif	/* VIEWER_FIELD_CANVAS_H_INCLUDED */
