#ifndef	   GTK_UPDATOR_H_INCLUDED
#define	   GTK_UPDATOR_H_INCLUDED

// Author:		H. Shimora
// Created:		Jun 17 2001
// Version:		0.00

///-----------------------------------------------
/// Change Log:
///-----------------------------------------------
// version 0.00  Jun 17 2001    base version.
//
//

#include  "abstruct_updator.h"
#include  <gtk--.h>

class  Gtk_Updator : public Abstruct_Updator
{
protected:
	class  Internal_Updator : public Gtk::Widget
	{
	private:
		enum Update_Type { TYPE_UNKNOWN , TYPE_INTERVAL , TYPE_FD };
	private:
		ref_count_ptr<Abstruct_Updator::Callback>	callback;

		Update_Type	type;
		guint		fd_id;

		bool		running;

	private:
		gint		update();

	private:
		static	void	static_update_function( gpointer  data ,
							gint ,
							GdkInputCondition );

	public:
		Internal_Updator();

		void	set_interval_callback
			( const ref_count_ptr<Abstruct_Updator::Callback> & ,
			  long  /* msec */ );

		void	set_fd_callback
			( const ref_count_ptr<Abstruct_Updator::Callback> & ,
			  int  /* fd */ );

		void	stop();
	};

	Internal_Updator	internal_updator;

public:
		 Gtk_Updator();
	virtual	~Gtk_Updator();

	virtual	void	set_interval_callback
			( const ref_count_ptr<Abstruct_Updator::Callback> &  ,
			  long  /* msec */ );

	virtual	void	set_fd_callback
			( const ref_count_ptr<Abstruct_Updator::Callback> &  ,
			  int  /* fd */ );

	virtual	void	stop();
};


class  Gtk_Updator_Factory : public Abstruct_Updator_Factory
{
public:
	virtual	~Gtk_Updator_Factory();
	virtual	ref_count_ptr<Abstruct_Updator>		product() const;
};


#endif	/* GTK_UPDATOR_H_INCLUDED */
